
/*
 * This class is used to check results of equations to known results. 
 * If values differ by more then 6 figures they are reported as 
 * incorrect and the result value, tabel value and difference is 
 * displayed. If the case is correct 'GOOD' is displayed together
 * with the result value.
 */
public class HeimUnit {

    // This is the limit used to determine correct results
    private static final double limit = Math.pow(10, -7);

    public static void main(String args[]) {

	unitCase(QN.eta(0,1), 0.98998964, "eta");	
	unitCase(QN.eta(1,1), 0.98756399, "eta(1,1)");
	unitCase(QN.eta(2,1), 0.98516776, "eta(2,1)");
	unitCase(QN.eta(2,2), 0.84242385, "eta(2,2)");

	unitCase(QN.theta(0,1), 7.93991266, "theta");	
	unitCase(QN.theta(1,1), 7.92534503, "theta(1,1)");
	unitCase(QN.theta(2,1), 7.91095114, "theta(2,1)");
	unitCase(QN.theta(2,2), 7.04779227, "theta(2,2)");	

	unitCase(Constants.alphaPlus(), 0.01832211, "Alpha Plus");
	unitCase(Constants.alphaMinus(), 0.00812835, "Alpha Minus");

	unitCase(QN.Q1(1), 3, "Q1(1)");
	unitCase(QN.Q2(1), 3, "Q2(1)");
	unitCase(QN.Q3(1), 2, "Q3(1)");
	unitCase(QN.Q4(1), 1, "Q4(1)");

	unitCase(QN.Q1(2), 24, "Q1(2)");
	unitCase(QN.Q2(2), 31, "Q2(2)");
	unitCase(QN.Q3(2), 34, "Q3(2)");
	unitCase(QN.Q4(2), 15, "Q4(2)");

	unitCase(SelfCouplingFunction.B(1), 27, "B(1)");
	unitCase(SelfCouplingFunction.B(2), 26, "B(2)");

	unitCase(SelfCouplingFunction.H(1), 9, "H(1)");
	unitCase(SelfCouplingFunction.H(2), 104, "H(2)");

	unitCase(SelfCouplingFunction.A(1), 2787.59025432, "A(1)");
	unitCase(SelfCouplingFunction.A(2), 14727.57867072, "A(2)");
	
	unitCase(QN.N1(1,1), 0.99688127, "N1(1,1)");
	unitCase(QN.N1(1,0), 1, "N1(1,0)");
	unitCase(QN.N1(2,1), 0.99627809, "N1(2,1)");
	unitCase(QN.N1(2,0), 1, "N1(2,0)");
	unitCase(QN.N1(2,2), 0.95891826, "N1(2,2)");

	unitCase(QN.N2(1,1), 0.67506174, "N2(1,1)");
	unitCase(QN.N2(1,0), 0.66666667, "N2(1,0)");
	unitCase(QN.N2(2,1), 0.67670370, "N2(2,1)");
	unitCase(QN.N2(2,0), 0.66666667, "N2(2,0)");
	unitCase(QN.N2(2,2), 0.79136728, "N2(2,2)");

	unitCase(QN.N3(1,1), 1.95731764, "N3(1,1)");
	unitCase(QN.N3(1,0), 2, "N3(1,0)");
	unitCase(QN.N3(2,1), 2.59881924, "N3(2,1)");
	unitCase(QN.N3(2,0), 2.71828183, "N3(2,0)");
	unitCase(QN.N3(2,2), 2.12190443, "N3(2,2)");

	unitCase(QN.N4(1,1), 4, "N4(1,1)");
	unitCase(QN.N4(1,0), 4, "N4(1,0)");
	unitCase(QN.N4(2,1), 4, "N4(2,1)");
	unitCase(QN.N4(2,0), 2, "N4(2,0)");
	unitCase(QN.N4(2,2), 6, "N4(2,2)");

	unitCase(QN.N5(1,1), 1.15773470, "N5(1,1)");
	unitCase(QN.N5(1,0), 1.15773470, "N5(1,0)");
	unitCase(QN.N5(2,1), 1.73247496, "N5(2,1)");
	unitCase(QN.N5(2,0), 1.15773470, "N5(2,0)");
	unitCase(QN.N5(2,2), 76.73214581, "N5(2,2)");

	unitCase(QN.N6(1,1), 0.00000164, "N6(1,1)");
	unitCase(QN.N6(1,0), 0.00000164, "N6(1,0)");
	unitCase(QN.N6(2,1), 0.02518725, "N6(2,1)");
	unitCase(QN.N6(2,0), -0.10493009, "N6(2,0)");
	unitCase(QN.N6(2,2), 0.15580107, "N6(2,2)");

	unitCase(SelfCouplingFunction.a1(1, 1, 1, 1, 0), 35, "a1 Lepton e_+-");
	unitCase(SelfCouplingFunction.a1(1, 0, 1, 1, 0), 34, "a1 Lepton e_0");
	unitCase(SelfCouplingFunction.a1(1, 1, 1, 1, 1), 1, "a1 Lepton mu");
	unitCase(SelfCouplingFunction.a1(1, 1, 2, 0, 0), 25, "a1 Messon pi_+-");
	unitCase(SelfCouplingFunction.a1(1, 0, 2, 0, 0), 22, "a1 Messon pi_0");
	unitCase(SelfCouplingFunction.a1(1, 0, 0, 0, 0), 28, "a1 Messon eta");
	unitCase(SelfCouplingFunction.a1(1, 1, 1, 0, 1), 16, "a1 Messon K_+-");
	unitCase(SelfCouplingFunction.a1(1, 0, 1, 0, 1), 22, "a1 Messon K_0");
	unitCase(SelfCouplingFunction.a1(2, 1, 1, 1, 0), 0, "a1 Baryon p");
	unitCase(SelfCouplingFunction.a1(2, 0, 1, 1, 0), 0, "a1 Baryon n");
	unitCase(SelfCouplingFunction.a1(2, 0, 0, 1, 0), 13, "a1 Baryon lambda");
	unitCase(SelfCouplingFunction.a1(2, 1, 2, 1, 0), 21, "a1 Baryon sigma_+");
	unitCase(SelfCouplingFunction.a1(2, 1, 2, 1, 0), 21, "a1 Baryon sigma_-");
	unitCase(SelfCouplingFunction.a1(2, 0, 2, 1, 0), 21, "a1 Baryon sigma_0");
	unitCase(SelfCouplingFunction.a1(2, 1, 1, 1, 1), 26, "a1 Baryon xi_-");
	unitCase(SelfCouplingFunction.a1(2, 0, 1, 1, 1), 26, "a1 Baryon xi_0");
	unitCase(SelfCouplingFunction.a1(2, 1, 0, 3, 0), 47, "a1 Baryon omega_-");
	unitCase(SelfCouplingFunction.a1(2, 2, 3, 3, 0), 23, "a1 Baryon delta_++");
	unitCase(SelfCouplingFunction.a1(2, 1, 3, 3, 0), 23, "a1 Baryon delta_+");
	unitCase(SelfCouplingFunction.a1(2, 0, 3, 3, 0), 23, "a1 Baryon delta_0");
	unitCase(SelfCouplingFunction.a1(2, 1, 3, 3, 0), 21, "a1 Baryon delta_-");

	unitCase(SelfCouplingFunction.a2(1, 1, 1, 1, 0, -1), 11, "a2 Lepton e_+-");
	unitCase(SelfCouplingFunction.a2(1, 0, 1, 1, 0, 0), 28, "a2 Lepton e_0");
	unitCase(SelfCouplingFunction.a2(1, 1, 1, 1, 1, -1), 23, "a2 Lepton mu");
	unitCase(SelfCouplingFunction.a2(1, 1, 2, 0, 0, -1), 0, "a2 Messon pi_+-");
	unitCase(SelfCouplingFunction.a2(1, 0, 2, 0, 0, 0), 2, "a2 Messon pi_0");
	unitCase(SelfCouplingFunction.a2(1, 0, 0, 0, 0, 0), 33, "a2 Messon eta");
	unitCase(SelfCouplingFunction.a2(1, 1, 1, 0, 1, -1), 31, "a2 Messon K_+-");
	unitCase(SelfCouplingFunction.a2(1, 0, 1, 0, 1, 0), 17, "a2 Messon K_0");
	unitCase(SelfCouplingFunction.a2(2, 1, 1, 1, 0, 1), 23, "a2 Baryon p");
	unitCase(SelfCouplingFunction.a2(2, 0, 1, 1, 0, 0), 36, "a2 Baryon n");
	unitCase(SelfCouplingFunction.a2(2, 0, 0, 1, 0, 0), 45, "a2 Baryon lambda");
	unitCase(SelfCouplingFunction.a2(2, 1, 2, 1, 0, 1), 30, "a2 Baryon sigma_+");
	unitCase(SelfCouplingFunction.a2(2, 1, 2, 1, 0, -1), 47, "a2 Baryon sigma_-");
	unitCase(SelfCouplingFunction.a2(2, 0, 2, 1, 0, 0), 46, "a2 Baryon sigma_0");
	unitCase(SelfCouplingFunction.a2(2, 1, 1, 1, 1, -1), 25, "a2 Baryon xi_-");
	unitCase(SelfCouplingFunction.a2(2, 0, 1, 1, 1, 0), 22, "a2 Baryon xi_0");
	unitCase(SelfCouplingFunction.a2(2, 1, 0, 3, 0, -1), 3, "a2 Baryon omega_-");
	unitCase(SelfCouplingFunction.a2(2, 2, 3, 3, 0, 2), 27, "a2 Baryon delta_++");
	unitCase(SelfCouplingFunction.a2(2, 1, 3, 3, 0, 1), 22, "a2 Baryon delta_+");
	unitCase(SelfCouplingFunction.a2(2, 0, 3, 3, 0, 0), 39, "a2 Baryon delta_0");
	unitCase(SelfCouplingFunction.a2(2, 1, 3, 3, 0, -1), 27, "a2 Baryon delta_-");

	unitCase(SelfCouplingFunction.a3(1, 1, 1, 1, 0, -1), 89.96774158, "a3 Lepton e_+-");
	unitCase(SelfCouplingFunction.a3(1, 0, 1, 1, 0, 0), 77.11059862, "a3 Lepton e_0");
	unitCase(SelfCouplingFunction.a3(1, 1, 1, 1, 1, -1), 7.26891022, "a3 Lepton mu");
	unitCase(SelfCouplingFunction.a3(1, 1, 2, 0, 0, -1), 95.62488526, "a3 Messon pi_+-");
	unitCase(SelfCouplingFunction.a3(1, 0, 2, 0, 0, 0), -0.03225806, "a3 Messon pi_0");
	unitCase(SelfCouplingFunction.a3(1, 0, 0, 0, 0, 0), 48.65020426, "a3 Messon eta");
	unitCase(SelfCouplingFunction.a3(1, 1, 1, 0, 1, -1), 7.26891022, "a3 Messon K_+-");
	unitCase(SelfCouplingFunction.a3(1, 0, 1, 0, 1, 0), 98.29474138, "a3 Messon K_0");
	unitCase(SelfCouplingFunction.a3(2, 1, 1, 1, 0, 1), 84.22944059, "a3 Baryon p");
	unitCase(SelfCouplingFunction.a3(2, 0, 1, 1, 0, 0), 101.15000035, "a3 Baryon n");
	unitCase(SelfCouplingFunction.a3(2, 0, 0, 1, 0, 0), -0.033333333, "a3 Baryon lambda");
	unitCase(SelfCouplingFunction.a3(2, 1, 2, 1, 0, 1), 26.15371691, "a3 Baryon sigma_+");
	unitCase(SelfCouplingFunction.a3(2, 1, 2, 1, 0, -1), 94.49556347, "a3 Baryon sigma_-");
	unitCase(SelfCouplingFunction.a3(2, 0, 2, 1, 0, 0), 83.86257747, "a3 Baryon sigma_0");
	unitCase(SelfCouplingFunction.a3(2, 1, 1, 1, 1, -1), 15.61504747, "a3 Baryon xi_-");
	unitCase(SelfCouplingFunction.a3(2, 0, 1, 1, 1, 0), 71.62409771, "a3 Baryon xi_0");
	unitCase(SelfCouplingFunction.a3(2, 1, 0, 3, 0, -1), 69.73881899, "a3 Baryon omega_-");
	unitCase(SelfCouplingFunction.a3(2, 2, 3, 3, 0, 2), 82.92386515, "a3 Baryon delta_++");
	unitCase(SelfCouplingFunction.a3(2, 1, 3, 3, 0, 1), 22.64335811, "a3 Baryon delta_+");
	unitCase(SelfCouplingFunction.a3(2, 0, 3, 3, 0, 0), 93.76289283, "a3 Baryon delta_0");
	unitCase(SelfCouplingFunction.a3(2, 1, 3, 3, 0, -1), 69.73881899, "a3 Baryon delta_-");

	unitCase(SelfCouplingFunction.W(1, 1, 1, 1, 0, -1), 38.70294226, "W_N=0 Lepton e_+-");
	unitCase(SelfCouplingFunction.W(1, 0, 1, 1, 0, 0), 38.51308957, "W_N=0 Lepton e_0");
	unitCase(SelfCouplingFunction.W(1, 1, 1, 1, 1, -1), 2830.2632345, "W_N=0 Lepton mu");
	unitCase(SelfCouplingFunction.W(1, 1, 2, 0, 0, -1), 3514.46294316, "W_N=0 Messon pi_+-");
	unitCase(SelfCouplingFunction.W(1, 0, 2, 0, 0, 0), 3419.16217346, "W_N=0 Messon pi_0");
	unitCase(SelfCouplingFunction.W(1, 0, 0, 0, 0, 0), 9905.00599107, "W_N=0 Messon eta");
	unitCase(SelfCouplingFunction.W(1, 1, 1, 0, 1, -1), 8857.95769020, "W_N=0 Messon K_+-");
	unitCase(SelfCouplingFunction.W(1, 0, 1, 0, 1, 0), 9332.35821820, "W_N=0 Messon K_0");
	unitCase(SelfCouplingFunction.W(2, 1, 1, 1, 0, 1), 14792.56308050, "W_N=0 Baryon p");
	unitCase(SelfCouplingFunction.W(2, 0, 1, 1, 0, 0), 14828.61089116, "W_N=0 Baryon n");
	unitCase(SelfCouplingFunction.W(2, 0, 0, 1, 0, 0), 16827.97671482, "W_N=0 Baryon lambda");
	unitCase(SelfCouplingFunction.W(2, 1, 2, 1, 0, 1), 18124.03136129, "W_N=0 Baryon sigma_+");
	unitCase(SelfCouplingFunction.W(2, 1, 2, 1, 0, -1), 18183.30294347, "W_N=0 Baryon sigma_-");
	unitCase(SelfCouplingFunction.W(2, 0, 2, 1, 0, 0), 18179.59733741, "W_N=0 Baryon sigma_0");
	unitCase(SelfCouplingFunction.W(2, 1, 1, 1, 1, -1), 18998.73451193, "W_N=0 Baryon xi_-");
	unitCase(SelfCouplingFunction.W(2, 0, 1, 1, 1, 0), 18990.08927597, "W_N=0 Baryon xi_0");
	unitCase(SelfCouplingFunction.W(2, 1, 0, 3, 0, -1), 23157.61451004, "W_N=0 Baryon omega_-");
	unitCase(SelfCouplingFunction.W(2, 2, 3, 3, 0, 2), 18115.38391620, "W_N=0 Baryon delta_++");
	unitCase(SelfCouplingFunction.W(2, 1, 3, 3, 0, 1), 18467.56082305, "W_N=0 Baryon delta_+");
	unitCase(SelfCouplingFunction.W(2, 0, 3, 3, 0, 0), 18508.94119539, "W_N=0 Baryon delta_0");
	unitCase(SelfCouplingFunction.W(2, 1, 3, 3, 0, -1), 18448.51703290, "W_N=0 Baryon delta_-");

	unitCase(SelfCouplingFunction.phi(1, 1, 0, 0, 1, 1, 0, -1), 0, "Mass Lepton e_+-");
	unitCase(SelfCouplingFunction.phi(1, 0, 0, 1, 1, 1, 0, 0), 0, "Mass Lepton e_0");
	unitCase(SelfCouplingFunction.phi(1, 1, 11, 6, 1, 1, 1, -1), 2.57120915, "Mass Lepton mu");
	unitCase(SelfCouplingFunction.phi(1, 1, 2, 3, 2, 0, 0, -1), -2.32863274, "Mass Messon pi_+-");
	unitCase(SelfCouplingFunction.phi(1, 0, 6, 4, 2, 0, 0, 0), -5.12094079, "Mass Messon pi_0");
	unitCase(SelfCouplingFunction.phi(1, 0, 17, 14, 0, 0, 0, 0), 5.06612007, "Mass Messon eta");
	unitCase(SelfCouplingFunction.phi(1, 1, 30, 28, 1, 0, 1, -1), -40.78574065, "Mass Messon K_+-");
	unitCase(SelfCouplingFunction.phi(1, 0, 5, 2, 1, 0, 1, 0), -12.73395842, "Mass Messon K_0");
	unitCase(SelfCouplingFunction.phi(2, 1, 0, 0, 1, 1, 0, 1), 9.28034058, "Mass Baryon p");
	unitCase(SelfCouplingFunction.phi(2, 0, -2, 17, 1, 1, 0, 0), 11.16885467, "Mass Baryon n");
	unitCase(SelfCouplingFunction.phi(2, 0, 0, -11, 0, 1, 0, 0), 0, "Mass Baryon lambda");
	unitCase(SelfCouplingFunction.phi(2, 1, -12, 10, 2, 1, 0, 1), -6.00947753, "Mass Baryon sigma_+");
	unitCase(SelfCouplingFunction.phi(2, 1, -5, -8, 2, 1, 0, -1), -2.01125294, "Mass Baryon sigma_-");
	unitCase(SelfCouplingFunction.phi(2, 0, -14, -2, 2, 1, 0, 0), 11.78154008, "Mass Baryon sigma_0");
	unitCase(SelfCouplingFunction.phi(2, 1, -17, 2, 1, 1, 1, -1), 23.44132266, "Mass Baryon xi_-");
	unitCase(SelfCouplingFunction.phi(2, 0, -1, 6, 1, 1, 1, 0), 90.44612205, "Mass Baryon xi_0");
	unitCase(SelfCouplingFunction.phi(2, 1, -1, -15, 0, 3, 0, -1), -137.03604095, "Mass Baryon omega_-");
	unitCase(SelfCouplingFunction.phi(2, 2, 9, 4, 3, 3, 0, 2), -1364.07751672, "Mass Baryon delta_++");
	unitCase(SelfCouplingFunction.phi(2, 1, -1, -6, 3, 3, 0, 1), -623.74523006, "Mass Baryon delta_+");
	unitCase(SelfCouplingFunction.phi(2, 0, -10, 2, 3, 3, 0, 0), -985.00227539, "Mass Baryon delta_0");
	unitCase(SelfCouplingFunction.phi(2, 1, -16, -15, 3, 3, 0, -1), -548.14408156, "Mass Baryon delta_-");

	unitCase(MainFunctions.massEquation(1, 1, 0, 0, 0, 0, 1, 1, 0, -1), 0.51099891844, "Mass Lepton e_+-");
	unitCase(MainFunctions.massEquation(1, 0, 0, 0, 0, 1, 1, 1, 0, 0), 0.51617049, "Mass Lepton e_0");
	unitCase(MainFunctions.massEquation(1, 1, 11, 6, 11, 6, 1, 1, 1, -1), 105.658389, "Mass Lepton mu");
	unitCase(MainFunctions.massEquation(1, 1, 12, 9, 2, 3, 2, 0, 0, -1), 139.57018, "Mass Messon pi_+-");
	unitCase(MainFunctions.massEquation(1, 0, 12, 3, 6, 4, 2, 0, 0, 0), 134.9766, "Mass Messon pi_0");
	unitCase(MainFunctions.massEquation(1, 0, 18, 22, 17, 14, 0, 0, 0, 0), 547.30, "Mass Messon eta");
	unitCase(MainFunctions.massEquation(1, 1, 17, 26, 30, 28, 1, 0, 1, -1), 493.677, "Mass Messon K_+-");
	unitCase(MainFunctions.massEquation(1, 0, 18, 5, 5, 2, 1, 0, 1, 0), 497.672, "Mass Messon K_0");
	unitCase(MainFunctions.massEquation(2, 1, 0, 0, 0, 0, 1, 1, 0, 1), 938.27231, "Mass Baryon p");
	unitCase(MainFunctions.massEquation(2, 0, 0, 0, -2, 17, 1, 1, 0, 0), 939.56563, "Mass Baryon n");
	unitCase(MainFunctions.massEquation(2, 0, 1, 3, 0, -11, 0, 1, 0, 0), 1115.683, "Mass Baryon lambda");
	unitCase(MainFunctions.massEquation(2, 1, 2, -7, -12, 10, 2, 1, 0, 1), 1189.37, "Mass Baryon sigma_+");
	unitCase(MainFunctions.massEquation(2, 1, 2, -6, -5, -8, 2, 1, 0, -1), 1197.449, "Mass Baryon sigma_-");
	unitCase(MainFunctions.massEquation(2, 0, 2, -7, -14, -2, 2, 1, 0, 0), 1192.642, "Mass Baryon sigma_0");
	unitCase(MainFunctions.massEquation(2, 1, 2, 7, -17, 2, 1, 1, 1, -1), 1321.32, "Mass Baryon xi_-");
	unitCase(MainFunctions.massEquation(2, 0, 2, 6, -1, 6, 1, 1, 1, 0), 1314.9, "Mass Baryon xi_0");
	unitCase(MainFunctions.massEquation(2, 1, 4, 4, -1, -15, 0, 3, 0, -1), 1672.45, "Mass Baryon omega_-");
	unitCase(MainFunctions.massEquation(2, 2, 2, 1, 9, 4, 3, 3, 0, 2), 1232, "Mass Baryon delta_++");
	unitCase(MainFunctions.massEquation(2, 1, 2, -1, -1, -6, 3, 3, 0, 1), 1232, "Mass Baryon delta_+");
	unitCase(MainFunctions.massEquation(2, 0, 2, -1, -10, 2, 3, 3, 0, 0), 1232, "Mass Baryon delta_0");
	unitCase(MainFunctions.massEquation(2, 1, 2, -1, -16, -15, 3, 3, 0, -1), 1232, "Mass Baryon delta_-");
    }

    /*
     * If values differ by more then 6 figures they are reported as 
     * incorrect and the result value, tabel value and difference is 
     * displayed. If the case is correct 'GOOD' is displayed together
     * with the result value.
     */
    public static void unitCase(double result, double table, String equation) {

	double difference = Math.abs(result - table);

	if(difference < limit) {
	    System.out.println();
	    System.out.println("=====> "+equation+" GOOD");
	    System.out.println("result: " + result);
	    System.out.println();
	}
	else {
	    System.out.println();
	    System.out.println("=====> "+equation+" INCORRECT!!!");
	    System.out.println("result: " + result);
	    System.out.println(" table: " + table);
	    System.out.println("  diff: " + difference);
	    System.out.println();	    
	}

    }

}
